library ieee;
use ieee.std_logic_1164.all;


entity semaphore is
port (clk, rst, SEO: in std_logic;
      NSred,NSyellow,NSgreen: out std_logic;
      EWred,EWyellow,EWgreen: out std_logic;
      st,conto: out integer
);
end semaphore;

architecture beh of semaphore is
  type stati is (NSverde,NSgiallo,EWverde,EWgiallo);
  signal nextstate: stati;
 begin
     
    process (clk,rst)
      variable conta: integer;
      begin
        if rst='1' then nextstate <= NSverde;
        		st<= 0;
        		conta:=0;
        elsif clk'event and clk='0' then 
             case nextstate is
               when NSverde =>  conta:=conta+1;
               			if SEO = '1' and conta >= 60 
               				then nextstate <= NSgiallo;
               				     conta := 0;
               				     st<=1;
               				                  		
               		        else nextstate <= NSverde;
               		             
               			end if;
               when NSgiallo => conta:= conta+1;
               			if conta >= 2
               				then  nextstate <= EWverde;
               				      conta:=0;
               				      st<=2;
               							
               			else nextstate <= NSgiallo;
               			     
               			end if;
               when EWverde =>  conta:= conta+1;
        			
               			if conta>=30
               			       then nextstate <= EWgiallo;
               			            conta:= 0;
               			            st<= 3; 
               			else nextstate <= EWverde;
               			     
               			end if;
               when EWgiallo => conta:=conta+1;
        		
               			if conta>= 2 then nextstate <= NSverde;
               				           
               				           st<= 0;
                                else nextstate<= EWgiallo;
                                     
                                end if;
               when others => null;
             end case;
           end if;
           conto<=conta;
        end process;
    
   
    process(nextstate)
     begin
       case nextstate is
        when NSverde => NSred<= '0';
        		NSyellow <= '0';
        		NSgreen <= '1';
        		EWred<='1';
        		EWyellow<='0';
        		EWgreen<='0';
        when NSgiallo => NSred<= '0';
        		NSyellow <= '1';
        		NSgreen <= '0';
        		EWred<='1';
        		EWyellow<='0';
        		EWgreen<='0'; 
        		
        when EWverde => NSred<= '1';
        		NSyellow <= '0';
        		NSgreen <= '0';
        		EWred<='0';
        		EWyellow<='0';
        		EWgreen<='1';
        		
        when EWgiallo => NSred<= '1';
        		NSyellow <= '0';
        		NSgreen <= '0';
        		EWred<='0';
        		EWyellow<='1';
        		EWgreen<='0';
        		
        when others => null;
       end case;
  end process;
       
 
             			
 end beh;          			





