library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity tbcentro is
end tbcentro;

architecture tbbcentro of tbcentro is
component centro is
  port ( rst, clk, nw: in std_logic;
         din: in std_logic_vector(15 downto 0);
         ris: out std_logic_vector(15 downto 0 );
         ready: out std_logic
  );
 end component;
 
 signal rst, clk, nw:  std_logic;
 signal     din:  std_logic_vector(15 downto 0);
 signal        ris:  std_logic_vector(15 downto 0 );
 signal        ready:  std_logic;
 
 begin
 
 dut:  centro port map (rst,clk,nw,din,ris,ready);
 
 rst <= '1' after 0 ns, '0' after 10 ns;
  
  process
  begin
   clk <= '1';
   wait for 5 ns;
   clk <= '0';
   wait for 5 ns;
  end process;
  
  nw<= '0' after 0 ns, '1' after 10 ns, '0' after 20 ns;
  
  din <= conv_std_logic_vector(4,16) after 0 ns, 
         conv_std_logic_vector(1,16) after 30 ns,
         conv_std_logic_vector(2,16) after 40 ns,
         conv_std_logic_vector(3,16) after 70 ns,
         conv_std_logic_vector(4,16) after 80 ns,
         conv_std_logic_vector(5,16) after 110 ns,
         conv_std_logic_vector(6,16) after 120 ns,
         conv_std_logic_vector(7,16) after 150 ns,
         conv_std_logic_vector(8,16) after 160 ns;
  end tbbcentro;

